git-stash.shon commit Merge branch 'pt/am-builtin-abort-fix' (b7d2a15)
   1#!/bin/sh
   2# Copyright (c) 2007, Nanako Shiraishi
   3
   4dashless=$(basename "$0" | sed -e 's/-/ /')
   5USAGE="list [<options>]
   6   or: $dashless show [<stash>]
   7   or: $dashless drop [-q|--quiet] [<stash>]
   8   or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
   9   or: $dashless branch <branchname> [<stash>]
  10   or: $dashless [save [--patch] [-k|--[no-]keep-index] [-q|--quiet]
  11                       [-u|--include-untracked] [-a|--all] [<message>]]
  12   or: $dashless clear"
  13
  14SUBDIRECTORY_OK=Yes
  15OPTIONS_SPEC=
  16START_DIR=$(pwd)
  17. git-sh-setup
  18. git-sh-i18n
  19require_work_tree
  20cd_to_toplevel
  21
  22TMP="$GIT_DIR/.git-stash.$$"
  23TMPindex=${GIT_INDEX_FILE-"$(git rev-parse --git-path index)"}.stash.$$
  24trap 'rm -f "$TMP-"* "$TMPindex"' 0
  25
  26ref_stash=refs/stash
  27
  28if git config --get-colorbool color.interactive; then
  29       help_color="$(git config --get-color color.interactive.help 'red bold')"
  30       reset_color="$(git config --get-color '' reset)"
  31else
  32       help_color=
  33       reset_color=
  34fi
  35
  36no_changes () {
  37        git diff-index --quiet --cached HEAD --ignore-submodules -- &&
  38        git diff-files --quiet --ignore-submodules &&
  39        (test -z "$untracked" || test -z "$(untracked_files)")
  40}
  41
  42untracked_files () {
  43        excl_opt=--exclude-standard
  44        test "$untracked" = "all" && excl_opt=
  45        git ls-files -o -z $excl_opt
  46}
  47
  48clear_stash () {
  49        if test $# != 0
  50        then
  51                die "$(gettext "git stash clear with parameters is unimplemented")"
  52        fi
  53        if current=$(git rev-parse --verify --quiet $ref_stash)
  54        then
  55                git update-ref -d $ref_stash $current
  56        fi
  57}
  58
  59create_stash () {
  60        stash_msg="$1"
  61        untracked="$2"
  62
  63        git update-index -q --refresh
  64        if no_changes
  65        then
  66                exit 0
  67        fi
  68
  69        # state of the base commit
  70        if b_commit=$(git rev-parse --verify HEAD)
  71        then
  72                head=$(git rev-list --oneline -n 1 HEAD --)
  73        else
  74                die "$(gettext "You do not have the initial commit yet")"
  75        fi
  76
  77        if branch=$(git symbolic-ref -q HEAD)
  78        then
  79                branch=${branch#refs/heads/}
  80        else
  81                branch='(no branch)'
  82        fi
  83        msg=$(printf '%s: %s' "$branch" "$head")
  84
  85        # state of the index
  86        i_tree=$(git write-tree) &&
  87        i_commit=$(printf 'index on %s\n' "$msg" |
  88                git commit-tree $i_tree -p $b_commit) ||
  89                die "$(gettext "Cannot save the current index state")"
  90
  91        if test -n "$untracked"
  92        then
  93                # Untracked files are stored by themselves in a parentless commit, for
  94                # ease of unpacking later.
  95                u_commit=$(
  96                        untracked_files | (
  97                                GIT_INDEX_FILE="$TMPindex" &&
  98                                export GIT_INDEX_FILE &&
  99                                rm -f "$TMPindex" &&
 100                                git update-index -z --add --remove --stdin &&
 101                                u_tree=$(git write-tree) &&
 102                                printf 'untracked files on %s\n' "$msg" | git commit-tree $u_tree  &&
 103                                rm -f "$TMPindex"
 104                ) ) || die "Cannot save the untracked files"
 105
 106                untracked_commit_option="-p $u_commit";
 107        else
 108                untracked_commit_option=
 109        fi
 110
 111        if test -z "$patch_mode"
 112        then
 113
 114                # state of the working tree
 115                w_tree=$( (
 116                        git read-tree --index-output="$TMPindex" -m $i_tree &&
 117                        GIT_INDEX_FILE="$TMPindex" &&
 118                        export GIT_INDEX_FILE &&
 119                        git diff --name-only -z HEAD -- >"$TMP-stagenames" &&
 120                        git update-index -z --add --remove --stdin <"$TMP-stagenames" &&
 121                        git write-tree &&
 122                        rm -f "$TMPindex"
 123                ) ) ||
 124                        die "$(gettext "Cannot save the current worktree state")"
 125
 126        else
 127
 128                rm -f "$TMP-index" &&
 129                GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
 130
 131                # find out what the user wants
 132                GIT_INDEX_FILE="$TMP-index" \
 133                        git add--interactive --patch=stash -- &&
 134
 135                # state of the working tree
 136                w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
 137                die "$(gettext "Cannot save the current worktree state")"
 138
 139                git diff-tree -p HEAD $w_tree -- >"$TMP-patch" &&
 140                test -s "$TMP-patch" ||
 141                die "$(gettext "No changes selected")"
 142
 143                rm -f "$TMP-index" ||
 144                die "$(gettext "Cannot remove temporary index (can't happen)")"
 145
 146        fi
 147
 148        # create the stash
 149        if test -z "$stash_msg"
 150        then
 151                stash_msg=$(printf 'WIP on %s' "$msg")
 152        else
 153                stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
 154        fi
 155        w_commit=$(printf '%s\n' "$stash_msg" |
 156        git commit-tree $w_tree -p $b_commit -p $i_commit $untracked_commit_option) ||
 157        die "$(gettext "Cannot record working tree state")"
 158}
 159
 160store_stash () {
 161        while test $# != 0
 162        do
 163                case "$1" in
 164                -m|--message)
 165                        shift
 166                        stash_msg="$1"
 167                        ;;
 168                -q|--quiet)
 169                        quiet=t
 170                        ;;
 171                *)
 172                        break
 173                        ;;
 174                esac
 175                shift
 176        done
 177        test $# = 1 ||
 178        die "$(eval_gettext "\"$dashless store\" requires one <commit> argument")"
 179
 180        w_commit="$1"
 181        if test -z "$stash_msg"
 182        then
 183                stash_msg="Created via \"git stash store\"."
 184        fi
 185
 186        git update-ref --create-reflog -m "$stash_msg" $ref_stash $w_commit
 187        ret=$?
 188        test $ret != 0 && test -z $quiet &&
 189        die "$(eval_gettext "Cannot update \$ref_stash with \$w_commit")"
 190        return $ret
 191}
 192
 193save_stash () {
 194        keep_index=
 195        patch_mode=
 196        untracked=
 197        while test $# != 0
 198        do
 199                case "$1" in
 200                -k|--keep-index)
 201                        keep_index=t
 202                        ;;
 203                --no-keep-index)
 204                        keep_index=n
 205                        ;;
 206                -p|--patch)
 207                        patch_mode=t
 208                        # only default to keep if we don't already have an override
 209                        test -z "$keep_index" && keep_index=t
 210                        ;;
 211                -q|--quiet)
 212                        GIT_QUIET=t
 213                        ;;
 214                -u|--include-untracked)
 215                        untracked=untracked
 216                        ;;
 217                -a|--all)
 218                        untracked=all
 219                        ;;
 220                --help)
 221                        show_help
 222                        ;;
 223                --)
 224                        shift
 225                        break
 226                        ;;
 227                -*)
 228                        option="$1"
 229                        # TRANSLATORS: $option is an invalid option, like
 230                        # `--blah-blah'. The 7 spaces at the beginning of the
 231                        # second line correspond to "error: ". So you should line
 232                        # up the second line with however many characters the
 233                        # translation of "error: " takes in your language. E.g. in
 234                        # English this is:
 235                        #
 236                        #    $ git stash save --blah-blah 2>&1 | head -n 2
 237                        #    error: unknown option for 'stash save': --blah-blah
 238                        #           To provide a message, use git stash save -- '--blah-blah'
 239                        eval_gettextln "error: unknown option for 'stash save': \$option
 240       To provide a message, use git stash save -- '\$option'"
 241                        usage
 242                        ;;
 243                *)
 244                        break
 245                        ;;
 246                esac
 247                shift
 248        done
 249
 250        if test -n "$patch_mode" && test -n "$untracked"
 251        then
 252            die "Can't use --patch and --include-untracked or --all at the same time"
 253        fi
 254
 255        stash_msg="$*"
 256
 257        git update-index -q --refresh
 258        if no_changes
 259        then
 260                say "$(gettext "No local changes to save")"
 261                exit 0
 262        fi
 263        git reflog exists $ref_stash ||
 264                clear_stash || die "$(gettext "Cannot initialize stash")"
 265
 266        create_stash "$stash_msg" $untracked
 267        store_stash -m "$stash_msg" -q $w_commit ||
 268        die "$(gettext "Cannot save the current status")"
 269        say Saved working directory and index state "$stash_msg"
 270
 271        if test -z "$patch_mode"
 272        then
 273                git reset --hard ${GIT_QUIET:+-q}
 274                test "$untracked" = "all" && CLEAN_X_OPTION=-x || CLEAN_X_OPTION=
 275                if test -n "$untracked"
 276                then
 277                        git clean --force --quiet -d $CLEAN_X_OPTION
 278                fi
 279
 280                if test "$keep_index" = "t" && test -n $i_tree
 281                then
 282                        git read-tree --reset -u $i_tree
 283                fi
 284        else
 285                git apply -R < "$TMP-patch" ||
 286                die "$(gettext "Cannot remove worktree changes")"
 287
 288                if test "$keep_index" != "t"
 289                then
 290                        git reset
 291                fi
 292        fi
 293}
 294
 295have_stash () {
 296        git rev-parse --verify --quiet $ref_stash >/dev/null
 297}
 298
 299list_stash () {
 300        have_stash || return 0
 301        git log --format="%gd: %gs" -g --first-parent -m "$@" $ref_stash --
 302}
 303
 304show_stash () {
 305        ALLOW_UNKNOWN_FLAGS=t
 306        assert_stash_like "$@"
 307
 308        git diff ${FLAGS:---stat} $b_commit $w_commit
 309}
 310
 311show_help () {
 312        exec git help stash
 313        exit 1
 314}
 315
 316#
 317# Parses the remaining options looking for flags and
 318# at most one revision defaulting to ${ref_stash}@{0}
 319# if none found.
 320#
 321# Derives related tree and commit objects from the
 322# revision, if one is found.
 323#
 324# stash records the work tree, and is a merge between the
 325# base commit (first parent) and the index tree (second parent).
 326#
 327#   REV is set to the symbolic version of the specified stash-like commit
 328#   IS_STASH_LIKE is non-blank if ${REV} looks like a stash
 329#   IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
 330#   s is set to the SHA1 of the stash commit
 331#   w_commit is set to the commit containing the working tree
 332#   b_commit is set to the base commit
 333#   i_commit is set to the commit containing the index tree
 334#   u_commit is set to the commit containing the untracked files tree
 335#   w_tree is set to the working tree
 336#   b_tree is set to the base tree
 337#   i_tree is set to the index tree
 338#   u_tree is set to the untracked files tree
 339#
 340#   GIT_QUIET is set to t if -q is specified
 341#   INDEX_OPTION is set to --index if --index is specified.
 342#   FLAGS is set to the remaining flags (if allowed)
 343#
 344# dies if:
 345#   * too many revisions specified
 346#   * no revision is specified and there is no stash stack
 347#   * a revision is specified which cannot be resolve to a SHA1
 348#   * a non-existent stash reference is specified
 349#   * unknown flags were set and ALLOW_UNKNOWN_FLAGS is not "t"
 350#
 351
 352parse_flags_and_rev()
 353{
 354        test "$PARSE_CACHE" = "$*" && return 0 # optimisation
 355        PARSE_CACHE="$*"
 356
 357        IS_STASH_LIKE=
 358        IS_STASH_REF=
 359        INDEX_OPTION=
 360        s=
 361        w_commit=
 362        b_commit=
 363        i_commit=
 364        u_commit=
 365        w_tree=
 366        b_tree=
 367        i_tree=
 368        u_tree=
 369
 370        REV=$(git rev-parse --no-flags --symbolic --sq "$@") || exit 1
 371
 372        FLAGS=
 373        for opt
 374        do
 375                case "$opt" in
 376                        -q|--quiet)
 377                                GIT_QUIET=-t
 378                        ;;
 379                        --index)
 380                                INDEX_OPTION=--index
 381                        ;;
 382                        --help)
 383                                show_help
 384                        ;;
 385                        -*)
 386                                test "$ALLOW_UNKNOWN_FLAGS" = t ||
 387                                        die "$(eval_gettext "unknown option: \$opt")"
 388                                FLAGS="${FLAGS}${FLAGS:+ }$opt"
 389                        ;;
 390                esac
 391        done
 392
 393        eval set -- $REV
 394
 395        case $# in
 396                0)
 397                        have_stash || die "$(gettext "No stash found.")"
 398                        set -- ${ref_stash}@{0}
 399                ;;
 400                1)
 401                        :
 402                ;;
 403                *)
 404                        die "$(eval_gettext "Too many revisions specified: \$REV")"
 405                ;;
 406        esac
 407
 408        REV=$(git rev-parse --symbolic --verify --quiet "$1") || {
 409                reference="$1"
 410                die "$(eval_gettext "\$reference is not a valid reference")"
 411        }
 412
 413        i_commit=$(git rev-parse --verify --quiet "$REV^2") &&
 414        set -- $(git rev-parse "$REV" "$REV^1" "$REV:" "$REV^1:" "$REV^2:" 2>/dev/null) &&
 415        s=$1 &&
 416        w_commit=$1 &&
 417        b_commit=$2 &&
 418        w_tree=$3 &&
 419        b_tree=$4 &&
 420        i_tree=$5 &&
 421        IS_STASH_LIKE=t &&
 422        test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
 423        IS_STASH_REF=t
 424
 425        u_commit=$(git rev-parse --verify --quiet "$REV^3") &&
 426        u_tree=$(git rev-parse "$REV^3:" 2>/dev/null)
 427}
 428
 429is_stash_like()
 430{
 431        parse_flags_and_rev "$@"
 432        test -n "$IS_STASH_LIKE"
 433}
 434
 435assert_stash_like() {
 436        is_stash_like "$@" || {
 437                args="$*"
 438                die "$(eval_gettext "'\$args' is not a stash-like commit")"
 439        }
 440}
 441
 442is_stash_ref() {
 443        is_stash_like "$@" && test -n "$IS_STASH_REF"
 444}
 445
 446assert_stash_ref() {
 447        is_stash_ref "$@" || {
 448                args="$*"
 449                die "$(eval_gettext "'\$args' is not a stash reference")"
 450        }
 451}
 452
 453apply_stash () {
 454
 455        assert_stash_like "$@"
 456
 457        git update-index -q --refresh || die "$(gettext "unable to refresh index")"
 458
 459        # current index state
 460        c_tree=$(git write-tree) ||
 461                die "$(gettext "Cannot apply a stash in the middle of a merge")"
 462
 463        unstashed_index_tree=
 464        if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
 465                        test "$c_tree" != "$i_tree"
 466        then
 467                git diff-tree --binary $s^2^..$s^2 | git apply --cached
 468                test $? -ne 0 &&
 469                        die "$(gettext "Conflicts in index. Try without --index.")"
 470                unstashed_index_tree=$(git write-tree) ||
 471                        die "$(gettext "Could not save index tree")"
 472                git reset
 473        fi
 474
 475        if test -n "$u_tree"
 476        then
 477                GIT_INDEX_FILE="$TMPindex" git-read-tree "$u_tree" &&
 478                GIT_INDEX_FILE="$TMPindex" git checkout-index --all &&
 479                rm -f "$TMPindex" ||
 480                die 'Could not restore untracked files from stash'
 481        fi
 482
 483        eval "
 484                GITHEAD_$w_tree='Stashed changes' &&
 485                GITHEAD_$c_tree='Updated upstream' &&
 486                GITHEAD_$b_tree='Version stash was based on' &&
 487                export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
 488        "
 489
 490        if test -n "$GIT_QUIET"
 491        then
 492                GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
 493        fi
 494        if git merge-recursive $b_tree -- $c_tree $w_tree
 495        then
 496                # No conflict
 497                if test -n "$unstashed_index_tree"
 498                then
 499                        git read-tree "$unstashed_index_tree"
 500                else
 501                        a="$TMP-added" &&
 502                        git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
 503                        git read-tree --reset $c_tree &&
 504                        git update-index --add --stdin <"$a" ||
 505                                die "$(gettext "Cannot unstage modified files")"
 506                        rm -f "$a"
 507                fi
 508                squelch=
 509                if test -n "$GIT_QUIET"
 510                then
 511                        squelch='>/dev/null 2>&1'
 512                fi
 513                (cd "$START_DIR" && eval "git status $squelch") || :
 514        else
 515                # Merge conflict; keep the exit status from merge-recursive
 516                status=$?
 517                git rerere
 518                if test -n "$INDEX_OPTION"
 519                then
 520                        gettextln "Index was not unstashed." >&2
 521                fi
 522                exit $status
 523        fi
 524}
 525
 526pop_stash() {
 527        assert_stash_ref "$@"
 528
 529        if apply_stash "$@"
 530        then
 531                drop_stash "$@"
 532        else
 533                status=$?
 534                say "The stash is kept in case you need it again."
 535                exit $status
 536        fi
 537}
 538
 539drop_stash () {
 540        assert_stash_ref "$@"
 541
 542        git reflog delete --updateref --rewrite "${REV}" &&
 543                say "$(eval_gettext "Dropped \${REV} (\$s)")" ||
 544                die "$(eval_gettext "\${REV}: Could not drop stash entry")"
 545
 546        # clear_stash if we just dropped the last stash entry
 547        git rev-parse --verify --quiet "$ref_stash@{0}" >/dev/null ||
 548        clear_stash
 549}
 550
 551apply_to_branch () {
 552        test -n "$1" || die "$(gettext "No branch name specified")"
 553        branch=$1
 554        shift 1
 555
 556        set -- --index "$@"
 557        assert_stash_like "$@"
 558
 559        git checkout -b $branch $REV^ &&
 560        apply_stash "$@" && {
 561                test -z "$IS_STASH_REF" || drop_stash "$@"
 562        }
 563}
 564
 565PARSE_CACHE='--not-parsed'
 566# The default command is "save" if nothing but options are given
 567seen_non_option=
 568for opt
 569do
 570        case "$opt" in
 571        -*) ;;
 572        *) seen_non_option=t; break ;;
 573        esac
 574done
 575
 576test -n "$seen_non_option" || set "save" "$@"
 577
 578# Main command set
 579case "$1" in
 580list)
 581        shift
 582        list_stash "$@"
 583        ;;
 584show)
 585        shift
 586        show_stash "$@"
 587        ;;
 588save)
 589        shift
 590        save_stash "$@"
 591        ;;
 592apply)
 593        shift
 594        apply_stash "$@"
 595        ;;
 596clear)
 597        shift
 598        clear_stash "$@"
 599        ;;
 600create)
 601        shift
 602        create_stash "$*" && echo "$w_commit"
 603        ;;
 604store)
 605        shift
 606        store_stash "$@"
 607        ;;
 608drop)
 609        shift
 610        drop_stash "$@"
 611        ;;
 612pop)
 613        shift
 614        pop_stash "$@"
 615        ;;
 616branch)
 617        shift
 618        apply_to_branch "$@"
 619        ;;
 620*)
 621        case $# in
 622        0)
 623                save_stash &&
 624                say "$(gettext "(To restore them type \"git stash apply\")")"
 625                ;;
 626        *)
 627                usage
 628        esac
 629        ;;
 630esac